package betterwithengineering.ie;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BlockSteel;
import betterwithmods.common.blocks.mechanical.BlockCookingPot;
import blusunrize.immersiveengineering.api.IEProperties;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.BlockTypes_MetalsAll;
import blusunrize.immersiveengineering.common.blocks.BlockTypes_MetalsIE;
import blusunrize.immersiveengineering.common.blocks.metal.BlockTypes_MetalDecoration0;
import blusunrize.immersiveengineering.common.blocks.metal.BlockTypes_MetalDecoration1;
import blusunrize.immersiveengineering.common.blocks.metal.BlockTypes_MetalMultiblock;
import blusunrize.immersiveengineering.common.blocks.metal.TileEntityArcFurnace;
import blusunrize.immersiveengineering.common.blocks.multiblocks.MultiblockArcFurnace;
import blusunrize.immersiveengineering.common.blocks.stone.BlockTypes_StoneDecoration;
import blusunrize.immersiveengineering.common.util.Utils;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.oredict.OreDictionary;

public class BWMMultiBlockArcFurnance extends MultiblockArcFurnace {
    public static final BWMMultiBlockArcFurnance instance = new BWMMultiBlockArcFurnance();

    static ItemStack[][][] structure = new ItemStack[5][5][5];

    static {
        for (int h = 0; h < 5; h++)
            for (int l = 0; l < 5; l++)
                for (int w = 0; w < 5; w++) {
                    if (h == 0) {
                        if (l == 0 && w == 2)
                            structure[h][l][w] = BlockCookingPot.getStack(BlockCookingPot.EnumType.CRUCIBLE);
                        else if (l == 2 && (w == 0 || w == 4))
                            structure[h][l][w] = new ItemStack(IEContent.blockStorage, 1, BlockTypes_MetalsIE.STEEL.getMeta());
                        else if (l == 0 && w == 0)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration1, 1, BlockTypes_MetalDecoration1.STEEL_SCAFFOLDING_0.getMeta());
                        else if (l == 4 && w == 2)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration0, 1, BlockTypes_MetalDecoration0.HEAVY_ENGINEERING.getMeta());
                        else if (l == 4 || (l > 2 && (w == 0 || w == 4)))
                            structure[h][l][w] = new ItemStack(IEContent.blockSheetmetal, 1, BlockTypes_MetalsAll.STEEL.getMeta());
                        else
                            structure[h][l][w] = new ItemStack(IEContent.blockSheetmetalSlabs, 1, BlockTypes_MetalsAll.STEEL.getMeta());
                    } else if (h == 1) {
                        if (l == 2 && (w == 0 || w == 4))
                            structure[h][l][w] = new ItemStack(IEContent.blockStorage, 1, BlockTypes_MetalsIE.STEEL.getMeta());
                        else if (l == 0 && w == 0)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration0, 1, BlockTypes_MetalDecoration0.RS_ENGINEERING.getMeta());
                        else if (l == 4 && w > 0 && w < 4)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration0, 1, BlockTypes_MetalDecoration0.LIGHT_ENGINEERING.getMeta());
                        else if ((w == 0 || w == 4) && l > 2)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration0, 1, BlockTypes_MetalDecoration0.HEAVY_ENGINEERING.getMeta());
                        else if (l >= 2 && w > 0 && w < 4)
                            structure[h][l][w] = new ItemStack(IEContent.blockStoneDecoration, 1, BlockTypes_StoneDecoration.BLASTBRICK_REINFORCED.getMeta());
                    } else if (h == 2) {
                        if (l == 2 && (w == 0 || w == 4))
                            structure[h][l][w] = new ItemStack(IEContent.blockStorage, 1, BlockTypes_MetalsIE.STEEL.getMeta());
                        else if (l == 4 && w > 0 && w < 4)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration0, 1, BlockTypes_MetalDecoration0.LIGHT_ENGINEERING.getMeta());
                        else if (l == 4)
                            structure[h][l][w] = new ItemStack(IEContent.blockSheetmetal, 1, BlockTypes_MetalsAll.STEEL.getMeta());
                        else if (w > 0 && w < 4)
                            structure[h][l][w] = new ItemStack(IEContent.blockStoneDecoration, 1, BlockTypes_StoneDecoration.BLASTBRICK_REINFORCED.getMeta());
                    } else if (h == 3) {
                        if (l == 4 && w == 2)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration0, 1, BlockTypes_MetalDecoration0.LIGHT_ENGINEERING.getMeta());
                        else if (l == 4 && (w == 1 || w == 3))
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration1, 1, BlockTypes_MetalDecoration1.STEEL_SCAFFOLDING_0.getMeta());
                        else if (l > 0 && w > 0 && w < 4)
                            structure[h][l][w] = new ItemStack(IEContent.blockStoneDecoration, 1, BlockTypes_StoneDecoration.BLASTBRICK_REINFORCED.getMeta());
                    } else if (h == 4) {
                        if (l > 1 && w == 2)
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration0, 1, BlockTypes_MetalDecoration0.LIGHT_ENGINEERING.getMeta());
                        else if (l == 4 && (w == 1 || w == 3))
                            structure[h][l][w] = new ItemStack(IEContent.blockMetalDecoration1, 1, BlockTypes_MetalDecoration1.STEEL_SCAFFOLDING_0.getMeta());
                    }

                    if (structure[h][l][w] == null) {
                        structure[h][l][w] = ItemStack.field_190927_a;
                    }
                }
    }


    @Override
    public boolean isBlockTrigger(IBlockState state) {
        Block block = state.func_177230_c();
        if (block instanceof BlockCookingPot)
            return state.func_177229_b(BlockCookingPot.TYPE) == BlockCookingPot.EnumType.CRUCIBLE;
        return false;
    }

    @Override
    public ItemStack[][][] getStructureManual() {
        return structure;
    }

    @Override
    public IBlockState getBlockstateFromStack(int index, ItemStack stack) {
        if (!stack.func_190926_b()) {
            if (stack.func_77973_b() instanceof ItemBlock)
                return ((ItemBlock) stack.func_77973_b()).func_179223_d().func_176203_a(stack.func_77952_i());
        }
        return null;
    }

    @Override
    public boolean createStructure(World world, BlockPos pos, EnumFacing side, EntityPlayer player) {
        if (side == EnumFacing.UP || side == EnumFacing.DOWN)
            side = EnumFacing.func_176733_a(player.field_70177_z);
        BlockPos startPos = pos;
        side = side.func_176734_d();

        if (Utils.isOreBlockAt(world, startPos.func_177982_a(0, -1, 0), "scaffoldingSteel")
                && Utils.isBlockAt(world, startPos.func_177967_a(side, 2).func_177982_a(0, -1, 0), IEContent.blockMetalDecoration0, BlockTypes_MetalDecoration0.LIGHT_ENGINEERING.getMeta())) {
            startPos = startPos.func_177967_a(side, 2);
            side = side.func_176734_d();
        }

        boolean mirrored = false;
        boolean b = structureCheck(world, startPos, side, mirrored);
        if (!b) {
            mirrored = true;
            b = structureCheck(world, startPos, side, mirrored);
        }

        if (b) {
            IBlockState state = IEContent.blockMetalMultiblock.func_176203_a(BlockTypes_MetalMultiblock.ARC_FURNACE.getMeta());
            state = state.func_177226_a(IEProperties.FACING_HORIZONTAL, side);
            for (int l = 0; l < 5; l++)
                for (int w = -2; w <= 2; w++)
                    for (int h = 0; h < 5; h++)
                        if (!structure[h][l][w + 2].func_190926_b()) {
                            int ww = mirrored ? -w : w;
                            BlockPos pos2 = startPos.func_177967_a(side, l).func_177967_a(side.func_176746_e(), ww).func_177982_a(0, h, 0);

                            world.func_175656_a(pos2, state);
                            TileEntity curr = world.func_175625_s(pos2);
                            if (curr instanceof TileEntityArcFurnace) {
                                TileEntityArcFurnace tile = (TileEntityArcFurnace) curr;
                                tile.formed = true;
                                tile.pos = h * 25 + l * 5 + (w + 2);
                                tile.offset = new int[]{(side == EnumFacing.WEST ? -l + 2 : side == EnumFacing.EAST ? l - 2 : side == EnumFacing.NORTH ? ww : -ww), h - 1, (side == EnumFacing.NORTH ? -l + 2 : side == EnumFacing.SOUTH ? l - 2 : side == EnumFacing.EAST ? ww : -ww)};
                                tile.mirrored = mirrored;
                                tile.func_70296_d();
                                world.func_175641_c(pos2, IEContent.blockMetalMultiblock, 255, 0);
                            }
                        }
        }
        return b;
    }

    boolean structureCheck(World world, BlockPos startPos, EnumFacing dir, boolean mirror) {
        for (int l = 0; l < 5; l++)
            for (int w = -2; w <= 2; w++)
                for (int h = 0; h < 5; h++)
                    if (!structure[h][l][w + 2].func_190926_b()) {
                        int ww = mirror ? -w : w;
                        BlockPos pos = startPos.func_177967_a(dir, l).func_177967_a(dir.func_176746_e(), ww).func_177982_a(0, h, 0);

                        if (world.func_175623_d(pos))
                            return false;
                        if (OreDictionary.itemMatches(structure[h][l][w + 2], BlockCookingPot.getStack(BlockCookingPot.EnumType.CRUCIBLE), true)) {
                            IBlockState state = world.func_180495_p(pos);
                            if (state.func_177230_c() == BWMBlocks.COOKING_POTS)
                                return state.func_177229_b(BlockCookingPot.TYPE) == BlockCookingPot.EnumType.CRUCIBLE;
                        } else if (OreDictionary.itemMatches(structure[h][l][w + 2], new ItemStack(IEContent.blockMetalDecoration1, 1, BlockTypes_MetalDecoration1.STEEL_SCAFFOLDING_0.getMeta()), true)) {
                            if (!Utils.isOreBlockAt(world, pos, "scaffoldingSteel"))
                                return false;
                        } else if (OreDictionary.itemMatches(structure[h][l][w + 2], new ItemStack(IEContent.blockSheetmetal, 1, BlockTypes_MetalsAll.STEEL.getMeta()), true)) {
                            if (!Utils.isOreBlockAt(world, pos, "blockSheetmetalSteel"))
                                return false;
                        } else if (OreDictionary.itemMatches(structure[h][l][w + 2], new ItemStack(IEContent.blockSheetmetalSlabs, 1, BlockTypes_MetalsAll.STEEL.getMeta()), true)) {
                            if (!Utils.isOreBlockAt(world, pos, "slabSheetmetalSteel"))
                                return false;
                        } else if (OreDictionary.itemMatches(structure[h][l][w + 2], new ItemStack(IEContent.blockStorage, 1, BlockTypes_MetalsIE.STEEL.getMeta()), true)) {
                            if (!Utils.isOreBlockAt(world, pos, "blockSteel"))
                                return false;
                        } else {
                            Block b = Block.func_149634_a(structure[h][l][w + 2].func_77973_b());
                            if (b != null)
                                if (!Utils.isBlockAt(world, pos, b, structure[h][l][w + 2].func_77952_i()))
                                    return false;
                        }
                    }
        return true;
    }

}
